uses crt,dos;

type FullNetAdress=record
        Network:array[1..4] of byte;
        Node   :array[1..6] of byte;
end;

type ECBStructure=record
   LinkAddressOff:WORD;
   LinkAddressSeg:WORD;
   ESRAddressOff :WORD;
   ESRAddressSeg :WORD;
   InUse         :BYTE;
   CompCode      :BYTE;
   SockNum       :WORD;
   IPXWorkSpc    :array[1..4] of byte;
   DrvWorkSpc    :array[1..12] of byte;
   ImmAdd        :array[1..6] of byte;
   FragCount     :WORD;
   FragAddOfs    :WORD;
   FragAddSeg    :WORD;
   FragSize      :WORD;
end;

type IPXHeader=record
   Checksum    :WORD;
   Length      :WORD;
   Control     :BYTE;
   PacketType  :BYTE;
   DestNet     :array[1..4] of byte;
   DestNode    :array[1..6] of byte;
   DestSocket  :array[1..2] of byte;
   SourNet     :array[1..4] of byte;
   SourNode    :array[1..6] of byte;
   SourSock    :array[1..2] of byte;
   DataGram    :array[1..30+2048] of byte;
end;

var r:registers;
    name2,name,mode:string;
    myadd:fullnetadress;
    IPXR,IPXS:IPXHeader;
    ECBR,ECBS:ECBStructure;
    timeout:longint;
    f:file;
    add,cont,fss,cont2:longint;
    i:integer;
    pp,zw:pointer;
    se,os:word;
    t,tt:longint;
    c:searchrec;
    nofile:boolean;
    s:string;
    attr:word;
    s1:dirstr;
    s2:namestr;
    s3:extstr;
    dateimask,pathmask,createpath:string;
    count3:longint;

    subs:boolean;

const Version:string='- 3.0 -';
      SendSocket=$5555;
      ReceiveSocket=$5556;
      hex:string='0123456789ABCDEF';

function output(segment,offset,countx:word):String;
var a:byte;
begin
for a:=0 to countx do
begin
output[a shl 1+1]:=hex[1+mem[segment:offset+a]shr 4 and 15];
output[a shl 1+2]:=hex[1+mem[segment:offset+a]      and 15];
end;
output[0]:=char(countx shl 1+2);
end;

procedure MASTER_SCHICKT_PACKET;
begin
 ECBS.FragSize:=30+1024;
 IPXS.Length:=30+1024;
 repeat
  r.bx:=3;                 {20 send it with CHECKSUM}
  r.es:=seg(ECBS);
  r.si:=ofs(ECBS);
  intr($7a,r);
  repeat                    {RelenquishControl}
        r.ax:=0;
        r.bx:=$a;
        intr($7a,r);
  until ord(ECBS.inUse)=0;
  r.bx:=4;                  {listen on socket}
  r.es:=SEG(ECBR);
  r.si:=OFS(ECBR);
  intr($7a,r);
  repeat until (ECBR.InUSE=0);
 until IPXR.PacketType=2;
end;

procedure SLAVE_WILL_PACKET;
var habs:boolean;
begin
 habs:=false;
repeat
  r.bx:=4;                  {listen on socket}
  r.es:=SEG(ECBR);
  r.si:=OFS(ECBR);
  intr($7a,r);
  timeout:=0;
  while (ECBR.InUSE<>0) and  (timeout<$ff) do begin
        inc(timeout);
        repeat until (port[$3da] and 8=8) or (ECBR.InUSE=0);
  end;
{  if (ECBR.InUSE<>0) then begin
     r.bx:=22;              {verify checksum}
 {    r.es:=SEG(ECBR);
     r.si:=OFS(ECBR);
     intr($7a,r);
     if r.ax=0 then writeln('CRC oK.!') else begin writeln('CRC Failed!');timeout:=$ff;end;
  end;}
  if (timeout=$ff) then begin
      r.bx:=6;              {cancel event}
      r.es:=seg(ECBR);
      r.si:=ofs(ECBR);
      intr($7a,r);
      IPXS.PacketType:=03;  {ERROR}
  end else begin
      IPXS.PacketType:=02;  {OK}
      habs:=true;
  end;

  ECBS.FragSize:=30;
  IPXS.Length:=30;

  r.bx:=3;              {send it}
  r.es:=seg(ECBS);
  r.si:=ofs(ECBS);
  intr($7a,r);
  repeat                {RelenquishControl}
     r.ax:=0;
     r.bx:=$a;
     intr($7a,r);
  until ord(ECBS.inUse)=0;
until habs;
end;


procedure sendfile(txt1,crp:string);
var fs:longint;
    rr:word;
    count1,count2:longint;
    t1,t2,t3:string;

begin
 t:=0;
 assign(f,txt1);
 reset(f,1);
 fs:=filesize(f);
 inc(fss,fs);
 for i:=0 to 12 do IPXS.Datagram[i+1]:=ord(txt1[i]);
 for i:=0 to length(crp) do IPXS.DataGram[i+20]:=ord(crp[i]);
 IPXS.Datagram[14]:=fs        and 255;
 IPXS.Datagram[15]:=fs shr 8  and 255;
 IPXS.Datagram[16]:=fs shr 16 and 255;
 IPXS.Datagram[17]:=fs shr 24 and 255;
 IPXS.DataGram[18]:=223;

 write('Sende ',txt1:12,' mit ',fs:10,' Bytes.');
 gotoxy(43,wherey);
 write('[]');
 gotoxy(wherex-17,wherey);
 MASTER_SCHICKT_PACKET;
 count1:=0;

 count2:=fs shr 10+1;
 add:=16 shl 16 div count2;
 cont:=0;
 cont2:=0;

 blockread(f,pp^,65535,rr);
 repeat
   move(mem[se:(count1 and 63) shl 10],IPXS.Datagram[1],1024);
{   write('#');    }
   MASTER_SCHICKT_PACKET;
   inc(count1);
   if (count1 mod 64)=0 then blockread(f,pp^,65535,rr);

   while cont>65535 do
   begin
   write('');
   dec(cont,65536);
   inc(cont2);
   end;
   inc(cont,add);

 until count1=count2;

 for add:=cont2 to 15 do write('');
 gotoxy(wherex+2,wherey);

 if t=0 then inc(t);
 writeln('=( ',0.0182*fs/t:6:2,' KB/s )=');
 close(f);
end;

procedure receivefile;
var fs:longint;
    count1,count2:longint;
    crp:string;
    allok:boolean;
    take,take2:string;
    aaa:integer;
    savedir:string;

begin
  t:=0;
  SLAVE_WILL_PACKET;
  for i:=0 to 12 do name[i]:=char(IPXR.DataGram[1+i]);
  for i:=0 to IPXR.DataGram[20] do crp[i]:=char(IPXR.DataGram[i+20]);

  {$I-}
  getdir(0,savedir);
  allok:=false;
  take:=crp;
  repeat
   aaa:=pos('\',take);
   take2:=copy(take,1,aaa);
   chdir(take2);
   if IORESULT<>0 then begin
      mkdir(take2);
      chdir(take2);
   end;
   if aaa=length(take) then allok:=true;
   take:=copy(take,aaa+1,length(take)-aaa);
  until allok;

   chdir(savedir);
  {$I+}

   fs:=longint(IPXR.DataGram[14])+longint(IPXR.DataGram[15])shl 8+
       longint(IPXR.DataGram[16])shl 16+longint(IPXR.DataGram[17])shl 24;
   inc(fss,fs);
   write('Bekomme ',name:12,' mit ',fs:10,' Bytes.');
   gotoxy(43,wherey);
   write('[]');
   gotoxy(wherex-17,wherey);
   assign(f,'.\'+crp+name);
   rewrite(f,1);
   count1:=0;
   count2:=fs shr 10+1;
   add:=16 shl 16 div count2;
   cont:=0;
   cont2:=0;
   repeat
  {   write('#');}
     SLAVE_WILL_PACKET;
     move(IPXR.Datagram[1],mem[se:(count1 and 63) shl 10],1024);
     inc(count1);
     if (count1 mod 64)=0 then blockwrite(f,pp^,65535);

     while cont>65535 do
     begin
     write('');
     dec(cont,65536);
     inc(cont2);
     end;
     inc(cont,add);

   until count1=count2;

     for add:=cont2 to 15 do write('');
     gotoxy(wherex+2,wherey);

     blockwrite(f,pp^,fs mod 65535);
     if t=0 then inc(t);
     writeln('=( ',0.0182*fs/t:6:2,' KB/s )=');
   close(f);
end;


procedure dir(t:string);
var c:searchrec;
begin
findfirst(t+dateimask,55,c);
while doserror=0 do begin
if c.name[1]<>'.' then begin
if (c.attr and 16=16) and subs then dir(t+c.name+'\');
if (c.attr and 24=0) and (c.size<>0) then begin
     createpath:=copy(t,length(pathmask)+1,length(t)-length(pathmask));
     IPXS.Datagram[1]:=100;
     MASTER_SCHICKT_PACKET;

     sendfile(c.name,createpath);
end;
end;
findnext(c);
end;
end;



procedure MASTER;
var slavegefunden:boolean;
begin
ECBR.SockNum:=ReceiveSocket;
ECBS.SockNum:=SendSocket;
IPXS.DestSocket[1]:=lo(SendSocket);
IPXS.DestSocket[2]:=hi(SendSocket);
slavegefunden:=false;
writeln('MASTER versucht SLAVE zu finden.');
repeat
  IPXS.DataGram[1]:=100;
  r.bx:=3;                  {send it}
  r.es:=seg(ECBS);
  r.si:=ofs(ECBS);
  intr($7a,r);
  repeat                    {RelenquishControl}
        r.ax:=0;
        r.bx:=$a;
        intr($7a,r);
  until (ord(ECBS.inUse)=0) or (port[$60] and 127=1);

  r.bx:=6;
  r.es:=seg(ECBS);
  r.si:=ofs(ECBS);
  intr($7a,r);

  r.bx:=4;                  {listen on socket}
  r.es:=SEG(ECBR);
  r.si:=OFS(ECBR);
  intr($7a,r);
  timeout:=0;
  repeat
     inc(timeout);
     repeat until port[$3da] and 8=8;
  until (ECBR.InUSE=0) or (timeout>01000) or (port[$60]and 127=1);
  if (timeout>1000) or (port[$60]and 127=1) then begin

     r.bx:=6;
     r.es:=seg(ECBS);
     r.si:=ofs(ECBS);
     intr($7a,r);
     r.bx:=6;
     r.es:=seg(ECBR);
     r.si:=ofs(ECBR);
     intr($7a,r);
  end;
  if ECBR.InUSE=0 then begin
     if IPXR.Datagram[1]=101 then begin
         writeln('SLAVE auf Node ',output(seg(IPXR.Sournode),ofs(IPXR.Sournode),5),
                  ' im Netzwerk ',output(seg(IPXR.Sournet),ofs(IPXR.Sournet),3),' gefunden.');
         slavegefunden:=true;
     end;
  end;
until slavegefunden or (port[$60]=1);
 if slavegefunden then begin
    tt:=0;
    writeln('------------------------- Transfer wird gestartet ---------------------------');
    dir(name);
    IPXS.Datagram[1]:=110;
    MASTER_SCHICKT_PACKET;
    writeln('------------------------- Transfer abgeschlossen ----------------------------');
    if tt>0 then inc(tt);
     writeln('Es wurden ',fss shr 10,' Kb bertragen.');
     writeln('bertragungsrate : ',0.0182*fss/tt:7:2,' KB/s ');
     writeln('Bentigte Zeit : ',tt/1092:7:2,' min.');

 end;
end;

procedure SLAVE;
var mastergefunden:boolean;
begin
ECBR.SockNum:=SendSocket;
ECBS.SockNum:=ReceiveSocket;
IPXS.DestSocket[1]:=lo(ReceiveSocket);
IPXS.DestSocket[2]:=hi(ReceiveSocket);
mastergefunden:=false;
repeat
  writeln('SLAVE wartet auf MASTER.');
  r.bx:=4;                  {listen on socket}
  r.es:=SEG(ECBR);
  r.si:=OFS(ECBR);
  intr($7a,r);
  repeat until (ECBR.InUSE=0) or (port[$60]=1);
  if (ECBR.InUSE=0) then begin

     if IPXR.Datagram[1]=100 then begin
        writeln('MASTER auf Node ',output(seg(IPXR.Sournode),ofs(IPXR.Sournode),5),
                   ' im Netzwerk ',output(seg(IPXR.Sournet),ofs(IPXR.Sournet),3),' gefunden.');
        mastergefunden:=true;
     end;
  end;
until mastergefunden or (port[$60]=1);
if mastergefunden then begin
  IPXS.Datagram[1]:=101;
  r.bx:=3;                  {send it}
  r.es:=seg(ECBS);
  r.si:=ofs(ECBS);
  intr($7a,r);
  repeat                    {RelenquishControl}
        r.ax:=0;
        r.bx:=$a;
        intr($7a,r);
  until ord(ECBS.inUse)=0;
  tt:=0;
  nofile:=false;
  writeln('------------------------- Transfer wird gestartet ---------------------------');
  repeat
    SLAVE_WILL_PACKET;
    if IPXR.DataGram[1]=100 then receivefile;
  until IPXR.DataGram[1]=110;
  writeln('------------------------- Transfer abgeschlossen ----------------------------');

  if tt>0 then begin
     writeln('Es wurden ',fss shr 10,' KB bertragen.');
     writeln('bertragungsrate : ',0.0182*fss/tt:7:2,' KB/s ');
     writeln('Bentigte Zeit : ',tt/1092:7:2,' min.');
  end;
end;
end;

procedure timer;interrupt;assembler;
asm
db 66h
inc word ptr t
db 66h
inc word ptr tt
end;

begin
  r.ax:=3;
  intr($10,r);
  r.ax:=$7a00;
  r.bx:=12;
  intr($2f,r);
  writeln('iPX Copy Version ',version);
  if (r.al and 255<>255) then begin
     writeln('iPX nicht installiert !');
     exit;
  end;
  writeln('iPX installiert. -(iPX v',mem[r.es:r.bx],'.',mem[r.es:r.bx+1],')-');

  subs:=false;
  for i:=1 to paramcount do begin
      if (paramstr(i)='-s') or (paramstr(i)='/s') or
         (paramstr(i)='-S') or (paramstr(i)='/S') then subs:=true;
  end;

  fss:=0;
  getintvec(28,zw);
  setintvec(28,@timer);

  getmem(pp,65535);
  se:=seg(pp^);
  os:=0;
  write('Benutze Socket ',sendsocket,' zum senden...');
  r.bx:=0;
  r.ax:=0;
  r.dx:=sendsocket;
  intr($7a,r);
  if r.al=0 then writeln('[OK].') else writeln('[FAiL].');
  write('Benutze Socket ',receivesocket,' zum empfangen...');
  r.bx:=0;
  r.ax:=0;
  r.dx:=receivesocket;
  intr($7a,r);
  if r.al=0 then writeln('[OK].') else writeln('[FAiL].');
  if paramcount>=1 then begin
     s:=fexpand(paramstr(1));
     if s[length(s)] <> '\' then begin
        Assign(F, s);
        GetFAttr(F, Attr);
        if (DosError=0) and (Attr and Directory <> 0) then s:=s+'\';
     end;
     fsplit(s,s1,s2,s3);
     if s2='' then s2:='*';
     if s3='' then s3:='.*';
     s:=s1;
     pathmask:=s1;
     dateimask:=s2+s3;

     if paramcount=2 then name2:=paramstr(2) else name2:='.';
     mode:='MASTER';
     writeln('Computer Luft als MASTER und sendet ',pathmask+dateimask,' nach ',name2);
     if subs then writeln('Dateien in Unterverzeichnissen werden auch kopiert!.');
  end else begin
     writeln('Computer luft als SLAVE.');
     mode:='SLAVE';
  end;
  r.bx:=9;                  {Get Address}
  r.es:=seg(myadd);
  r.si:=ofs(myadd);
  intr($7a,r);
  writeln('Node Adresse ',output(seg(myadd),ofs(myadd)+4,5),' auf Netzwerk ',output(seg(myadd),ofs(myadd),3),'.');
{-------------------------------INIT ECBS--------------------------------}
  ECBS.LinkAddressOff:=0;
  ECBS.LinkAddressSeg:=0;
  ECBS.ESRAddressOff:=0;
  ECBS.ESRAddressSeg:=0;
{  ECBS.SockNum:=SendSocket;}
  ECBS.ImmAdd[1]:=255;
  ECBS.ImmAdd[2]:=255;
  ECBS.ImmAdd[3]:=255;
  ECBS.ImmAdd[4]:=255;
  ECBS.ImmAdd[5]:=255;
  ECBS.ImmAdd[6]:=255;
  ECBS.FragCount:=1;
  ECBS.FragAddOfs:=OFS(IPXS);
  ECBS.FragAddSeg:=SEG(IPXS);
  ECBS.FragSize :=30+1024;
{-------------------------------INIT ECBR--------------------------------}
  ECBR.LinkAddressOff:=0;
  ECBR.LinkAddressSeg:=0;
  ECBR.ESRAddressOff:=0;
  ECBR.ESRAddressSeg:=0;
{ECBR.SockNum:=ReceiveSocket;}
  ECBR.FragCount:=1;
  ECBR.FragAddOfs:=OFS(IPXR);
  ECBR.FragAddSeg:=SEG(IPXR);
  ECBR.FragSize:=30+1024;
{-------------------------------INIT IPXS--------------------------------}
  IPXS.Checksum:=0;
  IPXS.Length:=30+1024;   {Leange IPXHeader}
  IPXS.Control:=0;
  IPXS.PacketType:=0;
  IPXS.DestNet[1]:=0;
  IPXS.DestNet[2]:=0;     {default Network}
  IPXS.DestNet[3]:=0;
  IPXS.DestNet[4]:=0;
  IPXS.DestNode[1]:=255;
  IPXS.DestNode[2]:=255;
  IPXS.DestNode[3]:=255;  {default Node}
  IPXS.DestNode[4]:=255;
  IPXS.DestNode[5]:=255;
  IPXS.DestNode[6]:=255;
  IPXS.DestSocket[1]:=lo(SendSocket);
  IPXS.DestSocket[2]:=hi(SendSocket);
  IPXS.SourSock[1]:=lo($740);
  IPXS.SourSock[2]:=hi($740);
  name:=fexpand(name);
  if mode='MASTER' then MASTER else SLAVE;
  writeln('Schliee Socket ',sendsocket,'.');
  r.bx:=1;                      {close socket}
  r.ax:=0;
  r.dx:=sendsocket;
  intr($7a,r);
  writeln('Schliee Socket ',receivesocket,'.');
  r.bx:=1;                      {close socket}
  r.ax:=0;
  r.dx:=receivesocket;
  intr($7a,r);
  setintvec(28,zw);
end.